#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <dlfcn.h>

void foo(void) {
  printf("foo() called\n");
}

int main(int argc, char *argv[]) {
  void (*foo_p)(void);
  void *h;

  if (argc < 2) {
    fprintf(stderr, "test-dlopen filename\n");
    return 1;
  }

  fprintf(stderr, "\targv[1] is %s\n", argv[1]);

  h = dlopen(argv[1], RTLD_GLOBAL | RTLD_LAZY);
  fprintf(stderr, "\th is %p for %s\n", h, argv[1]);
  foo_p = (void (*)(void)) dlsym(h, "foo");
  fprintf(stderr, "\tfoo_p is %p\n", foo_p);
  if (foo_p) foo_p();
  if (h) dlclose(h);
  return 0;
}
